<?php

final class HarbormasterBuildStepSearchEngine
  extends PhabricatorApplicationSearchEngine {

  public function getResultTypeDescription() {
    return pht('Harbormaster Build Steps');
  }

  public function getApplicationClassName() {
    return PhabricatorHarbormasterApplication::class;
  }

  public function newQuery() {
    return new HarbormasterBuildStepQuery();
  }

  protected function buildCustomSearchFields() {
    return array();
  }

  protected function buildQueryFromParameters(array $map) {
    $query = $this->newQuery();

    return $query;
  }

  protected function getURI($path) {
    return '/harbormaster/step/'.$path;
  }

  protected function getBuiltinQueryNames() {
    return array(
      'all' => pht('All Steps'),
    );
  }

  public function buildSavedQueryFromBuiltin($query_key) {
    $query = $this->newSavedQuery();
    $query->setQueryKey($query_key);

    switch ($query_key) {
      case 'all':
        return $query;
    }

    return parent::buildSavedQueryFromBuiltin($query_key);
  }

  protected function renderResultList(
    array $plans,
    PhabricatorSavedQuery $query,
    array $handles) {
    assert_instances_of($plans, 'HarbormasterBuildStep');
    return null;
  }

}
